        TITLE   UD -- UNHIDE HIDDEN DIRECTORY
        PAGE    58,121
        NAME    HD
CODE    SEGMENT BYTE PUBLIC 'PROG'              ;start segment
INITIAL PROC    FAR                             ;start proc
        ASSUME  CS:CODE,DS:CODE                 ;set up segment addresses
        ORG     080H                            ;establish parm area address
PARMLEN DB      00H                             ;length of operator entry
PARMAR  DB      12 DUP(00)                      ;maximum entry: "12345678.012"
        ORG     100H                            ;skip over psp
BEGIN:  JMP     START                           ;skip over data definitions
DISPLIN DB      'Enter name of subdirectory: $' ;used if no parm entry
RESPONS DB      0DH,00H,12 DUP(00)              ;name entered by DISPLIN
SETUP   DB      15 DUP(00)                      ;edited directory name
ERRORL0 DB      'Invalid Request '              ;error message last resort
ERRORTP DB      '9 - '                          ;attempt number
ERRORNO DB      '9 ',0DH,0AH,'$'                ;actual AH value returned
ERRORL1 DB      'Path not found',0DH,0AH,'$'    ;error messages
ERRORL2 DB      'Access denied',0DH,0AH,'$'     ;if operator screws up
START:  MOV     AX,CS                           ;set up segment addresses for
        MOV     DS,AX                           ;real - they're all the same
        MOV     ES,AX                           ;for this .COM program
        CMP     PARMLEN,00H                     ;did operator enter anything?
        JE      SKIPPAR                         ;no: go ask for directory name
        MOV     CH,00H                          ;set up to slide operator
        MOV     CL,PARMLEN                      ;entry into SETUP  
        SUB     CL,01H                          ;first byte of parm is length
        MOV     SI,OFFSET PARMAR+1              ;so skip it and move one less
        JMP     LOADSET                         ;jump to common slide routine
SKIPPAR:MOV     AH,09H                          ;set up request for name
        MOV     DX,OFFSET DISPLIN               ;since operator didn't give one
        INT     21H                             ;call DOS
        MOV     AH,0AH                          ;go get operator entry 
        MOV     DX,OFFSET RESPONS               ;and put it in RESPONS
        INT     21H                             ;call DOS
        MOV     CH,00H                          ;set up to slide 
        MOV     CL,RESPONS+1                    ;RESPONS into 
        MOV     SI,OFFSET RESPONS+2             ;setup field
LOADSET:MOV     DI,OFFSET SETUP                 ;common loop to load SETUP
        REPZ    MOVSB                           ;with operator entry
        MOV     CX,0000H                        ;get file attrbiute
        MOV     AX,4300H                        ;of directory in question
        MOV     DX,OFFSET [SETUP]               ;using SETUP directory name
        MOV     ERRORTP,'1'                     ;set errortyp to first shot
        INT     21H                             ;call DOS
        JB      ERRDISP                         ;if there's an error go home
        AND     CL,0EFH                         ;must first turn off subdir
        MOV     AX,4301H                        ;attribute otherwise change
        MOV     DX,OFFSET [SETUP]               ;of hidden attrib won't take
        MOV     ERRORTP,'2'                     ;set errortyp to second shot
        INT     21H                             ;call DOS
        JB      ERRDISP                         ;if there's an error go home
        AND     CL,0FDH                         ;next turn off hidden attrib
        MOV     AX,4301H                        ;
        MOV     DX,OFFSET [SETUP]               ;
        MOV     ERRORTP,'3'                     ;set errortyp to third shot
        INT     21H                             ;call DOS
        JB      ERRDISP                         ;if there's an error go home
        OR      CL,010H                         ;turn subdir attrib back on
        MOV     AX,4301H                        ; 
        MOV     DX,OFFSET [SETUP]               ; 
        MOV     ERRORTP,'4'                     ;set errortyp to fourth shot
        INT     21H                             ;call DOS
        JB      ERRDISP                         ;if there's an error go home
NOERROR:INT     20H                             ;otherwise all done
ERRDISP:ADD     AX,0030H                        ;ERRDISP displays error msgs
        MOV     ERRORNO,AL                      ;by changing AL to displayable
        CMP     ERRORNO,'2'                     ;and then jumping to message
        JE      ERROR1                          ;disp. depending on AL return
        CMP     ERRORNO,'3'                     ;errors 2 and 3 indicate path
        JE      ERROR1                          ;couldn't be found
        CMP     ERRORNO,'5'                     ;error 5 indicates that 
        JE      ERROR2                          ;access was denied by DOS
        MOV     DX,OFFSET ERRORL0               ;no other possible-just in case
ERODISP:MOV     AH,09H                          ;actually display message
        INT     21H                             ;call DOS
        INT     20H                             ;and then return home
ERROR1: MOV     DX,OFFSET ERRORL1               ;set up error message 1
        JMP     ERODISP                         ;jump to error display
ERROR2: CMP     ERRORTP,34H                     ;access denied is ok on  
        JE      NOERROR                         ;reset of DIR attrib because
        MOV     DX,OFFSET ERRORL2               ;it takes anyway! otherwise
        JMP     ERODISP                         ;error display is legit 
INITIAL ENDP                                    ;end procedure         
CODE    ENDS                                    ;end segment
        END     BEGIN                           ;end program

